stages: # Lista de etapas
  - build
  - test
  - deploy
  - deployment-tests

build: # Nombre del trabajo
  image: gradle:7.6.1-jdk8
  stage: build # Etapa a la cual pertenece
  script: # Ejecutar scripts, comandos, etc
    - sh $CI_PROJECT_DIR/gradlew assemble

unit-test: # Nombre del trabajo
  image: gradle:7.6.1-jdk8
  stage: test # Etapa a la cual pertenece
  coverage: '/Instruction Coverage\s*: (\d+.\d+|\d+\d+)/' # Obtiene el porcentaje de cobertura
  script: # Ejecutar scripts, comandos, etc
    - sh $CI_PROJECT_DIR/gradlew test
  artifacts:
    paths:
      - build/jacocoHtml
      - build/reports

render-deploy: # Nombre del trabajo
  stage: deploy # Etapa a la cual pertenece
  script:
    - curl -X POST $RENDER_DEPLOY_HOOK # Despliegue en render

performance-test-jmeter: # Nombre del trabajo
  stage: deployment-tests # Etapa a la cual pertenece
  image: openjdk:8 # Imagen propia del trabajo
  script: # Ejecutar scripts, comandos, etc
    - wget https://dlcdn.apache.org/jmeter/binaries/apache-jmeter-5.5.tgz # Descargamos JMeter
    - tar -xzf apache-jmeter-5.5.tgz # Lo descomprimimos
    - mkdir /opt/apache-jmeter-5.5 # Creamos el directorio de JMeter
    - mv apache-jmeter-5.5/* /opt/apache-jmeter-5.5 # Movemos los archivos al directorio de JMeter
    - cd /opt/apache-jmeter-5.5/bin # Nos paramos en la carpeta de JMeter
    - sh jmeter -n -t $CI_PROJECT_DIR/performance-test/ms-ecommerce-orq.jmx -JvPROTOCOL=https -JvHOST="ms-ecommerce-orq.onrender.com" -JvPORT=443 -JvCONTEXT=/ms-ecommerce-orq -JvVERSION=/ -JvAMBIENTE=dev -JvTHREADS=10 -JvTIMEOUT=8000 -JvRAMP_UP=1 -LDEBUG -l test_results.jtl -e -o $CI_PROJECT_DIR/jmeter-result # Ejecutamos JMeter
  artifacts: # Artefactos que deseamos generar para el trabajo
    paths: # Rutas
      - jmeter-result/ # Carpeta de JMeter con el resultado de los test de rendimiento

# jmeter -JvPROTOCOL=http -JvHOST="localhost" -JvPORT=8080 -JvCONTEXT=/ms-ecommerce-orq -JvVERSION=/ -JvAMBIENTE=dev -JvTHREADS=10 -JvTIMEOUT=8000 -JvRAMP_UP=1